#include "LedsManager.h"


CPhidgetInterfaceKitHandle ifKit;


int interfacekit_simple_open()
{
	int result;
	const char *err;
	//Declare an InterfaceKit handle
	ifKit = 0;
	//create the InterfaceKit object
	CPhidgetInterfaceKit_create(&ifKit);
	//open the interfacekit for device connections
	CPhidget_open((CPhidgetHandle)ifKit, -1);
	//get the program to wait for an interface kit device to be attached
	printf("Waiting for interface kit to be attached....\n");
	if((result = CPhidget_waitForAttachment((CPhidgetHandle)ifKit, 10000)))
	{
		CPhidget_getErrorDescription(result, &err);
		printf("Problem waiting for attachment: %s\n", err);
		return 0;
	}
	return 0;
}

void interfacekit_simple_close()
{
	CPhidget_close((CPhidgetHandle)ifKit);
	CPhidget_delete((CPhidgetHandle)ifKit);
}

void LEDs_all_on()
{
	int i;
	interfacekit_simple_open();
	for (i=0;i<8;i++) {
		CPhidgetInterfaceKit_setOutputState (ifKit, i, 1);
	}
	interfacekit_simple_close();
}

void LEDs_all_off(){
	int i;
	interfacekit_simple_open();
	for (i=0;i<8;i++) {
		CPhidgetInterfaceKit_setOutputState (ifKit, i, 0);
	}
	interfacekit_simple_close();
}

void LEDs_red_on(){
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setOutputState (ifKit, 1, 1);
	CPhidgetInterfaceKit_setOutputState (ifKit, 3, 1);
	CPhidgetInterfaceKit_setOutputState (ifKit, 6, 1);
	interfacekit_simple_close();
}

void LEDs_red_off(){
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setOutputState (ifKit, 1, 0);
	CPhidgetInterfaceKit_setOutputState (ifKit, 3, 0);
	CPhidgetInterfaceKit_setOutputState (ifKit, 6, 0);
	interfacekit_simple_close();
}

void LEDs_blue_on(){
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setOutputState (ifKit, 2, 1);
	CPhidgetInterfaceKit_setOutputState (ifKit, 5, 1);
	CPhidgetInterfaceKit_setOutputState (ifKit, 7, 1);
	interfacekit_simple_close();
}

void LEDs_blue_off(){
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setOutputState (ifKit, 2, 0);
	CPhidgetInterfaceKit_setOutputState (ifKit, 5, 0);
	CPhidgetInterfaceKit_setOutputState (ifKit, 7, 0);
	interfacekit_simple_close();
}

void LEDs_white_on(){
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setOutputState (ifKit, 0, 1);
	CPhidgetInterfaceKit_setOutputState (ifKit, 4, 1);
	interfacekit_simple_close();
}

void LEDs_white_off(){
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setOutputState (ifKit, 0, 0);
	CPhidgetInterfaceKit_setOutputState (ifKit, 4, 0);
	interfacekit_simple_close();
}

