#include "TempSensor.h"


#define trigger 1

CPhidgetInterfaceKitHandle ifKit;

int interfacekit_simple_open()
{
	int result;
	const char *err;
	//Declare an InterfaceKit handle
	ifKit = 0;
	//create the InterfaceKit object
	CPhidgetInterfaceKit_create(&ifKit);
	//open the interfacekit for device connections
	CPhidget_open((CPhidgetHandle)ifKit, -1);
	//get the program to wait for an interface kit device to be attached
	printf("Waiting for interface kit to be attached....\n");
	if((result = CPhidget_waitForAttachment((CPhidgetHandle)ifKit, 10000)))
	{
		CPhidget_getErrorDescription(result, &err);
		printf("Problem waiting for attachment: %s\n", err);
		return 0;
	}
	return 0;
}

void interfacekit_simple_close()
{
	CPhidget_close((CPhidgetHandle)ifKit);
	CPhidget_delete((CPhidgetHandle)ifKit);
}

int getTemperatureEau(int *val) {
	int value;
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setSensorChangeTrigger(ifKit, 0, trigger);
	CPhidgetInterfaceKit_getSensorValue (ifKit, 0, &value);
	//printf("te: %d\n",value);
	*val = (int)((value*(- 0.72)) + 382);
	interfacekit_simple_close();
	return 0;
}

int getTemperatureAir(int *val) {
	int value;
	interfacekit_simple_open();
	CPhidgetInterfaceKit_setSensorChangeTrigger(ifKit, 1, trigger);
	CPhidgetInterfaceKit_getSensorValue (ifKit, 1, &value);
	//printf("ta: %d\n",value);
	*val = (int)((value*0.4) - 92);
	interfacekit_simple_close();
	return 0;
}
