/*   
Copyright 2006 - 2010 Intel Corporation

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#if defined(WIN32)
	#ifndef MICROSTACK_NO_STDAFX
		#include "stdafx.h"
	#endif
	#define _CRTDBG_MAP_ALLOC
	#include <TCHAR.h>
#endif

#if defined(WINSOCK2)
	#include <winsock2.h>
	#include <ws2tcpip.h>
#elif defined(WINSOCK1)
	#include <winsock.h>
	#include <wininet.h>
#endif
#include "ILibParsers.h"

#include "UPnPMicroStack.h"
#include "ILibWebServer.h"
#include "ILibAsyncSocket.h"
#include "LedsManager.h"

#if defined(WIN32)
	#include <crtdbg.h>
#endif

void *MicroStackChain;

void *UPnPmicroStack;

int WaitForExit = 0;
void *ILib_Monitor;
int ILib_IPAddressLength;
int *ILib_IPAddressList;



void UPnPLedsService_GetBlueLedStatus(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_GetBlueLedStatus();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_GetBlueLedStatus(upnptoken,1);
}

void UPnPLedsService_GetRedLedStatus(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_GetRedLedStatus();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_GetRedLedStatus(upnptoken,1);
}

void UPnPLedsService_GetWhiteLedStatus(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_GetWhiteLedStatus();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_GetWhiteLedStatus(upnptoken,1);
}

void UPnPLedsService_OffBlueLeds(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_OffBlueLeds();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	LEDs_blue_off();
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_OffBlueLeds(upnptoken);
}

void UPnPLedsService_OffRedLeds(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_OffRedLeds();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	LEDs_red_off();
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_OffRedLeds(upnptoken);
}

void UPnPLedsService_OffWhiteLeds(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_OffWhiteLeds();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	LEDs_white_off();
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_OffWhiteLeds(upnptoken);
}

void UPnPLedsService_OnBlueLeds(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_OnBlueLeds();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	LEDs_blue_on();
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_OnBlueLeds(upnptoken);
}

void UPnPLedsService_OnRedLeds(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_OnRedLeds();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	LEDs_red_on();
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_OnRedLeds(upnptoken);
}

void UPnPLedsService_OnWhiteLeds(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPLedsService_OnWhiteLeds();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	LEDs_white_on();
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_LedsService_OnWhiteLeds(upnptoken);
}



void ILib_IPAddressMonitor(void *data)
{
	int length;
	int *list;
	
	UNREFERENCED_PARAMETER( data );

	length = ILibGetLocalIPAddressList(&list);
	if (length != ILib_IPAddressLength || memcmp((void*)list, (void*)ILib_IPAddressList, sizeof(int)*length) != 0)
	{

UPnPIPAddressListChanged(UPnPmicroStack);
		free(ILib_IPAddressList);
		ILib_IPAddressList = list;
		ILib_IPAddressLength = length;
	}
	else
	{
		free(list);
	}
	ILibLifeTime_Add(ILib_Monitor, NULL, 4, (void*)&ILib_IPAddressMonitor, NULL);
}

void ILib_LinuxQuit(void *data)
{
	UNREFERENCED_PARAMETER( data );

	if(MicroStackChain != NULL)
	{
		ILibStopChain(MicroStackChain);
		MicroStackChain = NULL;
	}
}
void BreakSink(int s)
{
	if(WaitForExit == 0)
	{
		ILibLifeTime_Add(ILib_Monitor, NULL, 0, (void*)&ILib_LinuxQuit, NULL);
		WaitForExit = 1;
	}
}

int main(void) 
{
	struct sigaction setup_action;
    sigset_t block_mask;
     
	MicroStackChain = ILibCreateChain();


	// TODO: Each device must have a unique device identifier (UDN)
	UPnPmicroStack = UPnPCreateMicroStack(MicroStackChain, "LedsDevice", "f71e1cf1-6f04-4795-ac1f-d2cecf5913f5", "0000001", 1800, 0);


	UPnPFP_LedsService_GetBlueLedStatus = (UPnP_ActionHandler_LedsService_GetBlueLedStatus)&UPnPLedsService_GetBlueLedStatus;
	UPnPFP_LedsService_GetRedLedStatus = (UPnP_ActionHandler_LedsService_GetRedLedStatus)&UPnPLedsService_GetRedLedStatus;
	UPnPFP_LedsService_GetWhiteLedStatus = (UPnP_ActionHandler_LedsService_GetWhiteLedStatus)&UPnPLedsService_GetWhiteLedStatus;
	UPnPFP_LedsService_OffBlueLeds = (UPnP_ActionHandler_LedsService_OffBlueLeds)&UPnPLedsService_OffBlueLeds;
	UPnPFP_LedsService_OffRedLeds = (UPnP_ActionHandler_LedsService_OffRedLeds)&UPnPLedsService_OffRedLeds;
	UPnPFP_LedsService_OffWhiteLeds = (UPnP_ActionHandler_LedsService_OffWhiteLeds)&UPnPLedsService_OffWhiteLeds;
	UPnPFP_LedsService_OnBlueLeds = (UPnP_ActionHandler_LedsService_OnBlueLeds)&UPnPLedsService_OnBlueLeds;
	UPnPFP_LedsService_OnRedLeds = (UPnP_ActionHandler_LedsService_OnRedLeds)&UPnPLedsService_OnRedLeds;
	UPnPFP_LedsService_OnWhiteLeds = (UPnP_ActionHandler_LedsService_OnWhiteLeds)&UPnPLedsService_OnWhiteLeds;
	
	

// All evented state variables MUST be initialized before UPnPStart is called.
UPnPSetState_LedsService_StatusRedLed(UPnPmicroStack, 1);
UPnPSetState_LedsService_StatusBlueLed(UPnPmicroStack, 1);
UPnPSetState_LedsService_StatusWhiteLed(UPnPmicroStack, 1);

	printf("MicroStack 1.0 - LedsDevice \r\n\r\n");

ILib_Monitor = ILibCreateLifeTime(MicroStackChain);	ILib_IPAddressLength = ILibGetLocalIPAddressList(&ILib_IPAddressList);
	ILibLifeTime_Add(ILib_Monitor, NULL, 4, (void*)&ILib_IPAddressMonitor, NULL);
	sigemptyset(&block_mask);
	// Block other terminal-generated signals while handler runs.
    sigaddset(&block_mask, SIGINT);
    sigaddset(&block_mask, SIGQUIT);
    setup_action.sa_handler = BreakSink;
    setup_action.sa_mask = block_mask;
    setup_action.sa_flags = 0;
    sigaction(SIGINT, &setup_action, NULL);
	WaitForExit = 0;
	ILibStartChain(MicroStackChain);
	free(ILib_IPAddressList);
	return 0;
}

