/*   
Copyright 2006 - 2010 Intel Corporation

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#if defined(WIN32)
	#ifndef MICROSTACK_NO_STDAFX
		#include "stdafx.h"
	#endif
	#define _CRTDBG_MAP_ALLOC
	#include <TCHAR.h>
#endif

#if defined(WINSOCK2)
	#include <winsock2.h>
	#include <ws2tcpip.h>
#elif defined(WINSOCK1)
	#include <winsock.h>
	#include <wininet.h>
#endif
#include "ILibParsers.h"

#include "UPnPMicroStack.h"
#include "ILibWebServer.h"
#include "ILibAsyncSocket.h"

#if defined(WIN32)
	#include <crtdbg.h>
#endif

void *MicroStackChain;

void *UPnPmicroStack;

int WaitForExit = 0;
void *ILib_Monitor;
int ILib_IPAddressLength;
int *ILib_IPAddressList;

char radioAdress[50];
int pid;

void UPnPMusicService_assignAddress(UPnPSessionToken upnptoken,char* address)
{
	printf("Invoke: UPnPMusicService_assignAddress(%s);\r\n", address);
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	strcpy (radioAdress, address);;
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_MusicService_assignAddress(upnptoken);
}

void UPnPMusicService_play(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPMusicService_play();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	char cmd[100];
	strcpy (cmd, "wget -q -O - ");
	strcat (cmd, radioAdress);
	strcat (cmd, " | madplay -");
	printf("Invoke command : %s\r\n", cmd);
	
	if ( (pid = fork()) < 0) return 0;
	if (pid == 0) {
		execl("/bin/sh", "sh", "-c", cmd, (char *) 0);
	}
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_MusicService_play(upnptoken);
}

void UPnPMusicService_stop(UPnPSessionToken upnptoken)
{
	printf("Invoke: UPnPMusicService_stop();\r\n");
	
	/* If you intend to make the response later, you MUST reference count upnptoken with calls to ILibWebServer_AddRef() */
	/* and ILibWebServer_Release() */
	
	/* TODO: Place Action Code Here... */
	printf("kill pid : %d\n", pid);
	kill(pid+2, SIGTERM);
	
	/* UPnPResponse_Error(upnptoken, 404, "Method Not Implemented"); */
	UPnPResponse_MusicService_stop(upnptoken);
}



void ILib_IPAddressMonitor(void *data)
{
	int length;
	int *list;
	
	UNREFERENCED_PARAMETER( data );

	length = ILibGetLocalIPAddressList(&list);
	if (length != ILib_IPAddressLength || memcmp((void*)list, (void*)ILib_IPAddressList, sizeof(int)*length) != 0)
	{

UPnPIPAddressListChanged(UPnPmicroStack);
		free(ILib_IPAddressList);
		ILib_IPAddressList = list;
		ILib_IPAddressLength = length;
	}
	else
	{
		free(list);
	}
	ILibLifeTime_Add(ILib_Monitor, NULL, 4, (void*)&ILib_IPAddressMonitor, NULL);
}

void ILib_LinuxQuit(void *data)
{
	UNREFERENCED_PARAMETER( data );

	if(MicroStackChain != NULL)
	{
		ILibStopChain(MicroStackChain);
		MicroStackChain = NULL;
	}
}
void BreakSink(int s)
{
	if(WaitForExit == 0)
	{
		ILibLifeTime_Add(ILib_Monitor, NULL, 0, (void*)&ILib_LinuxQuit, NULL);
		WaitForExit = 1;
	}
}

int main(void) 
{
	struct sigaction setup_action;
    sigset_t block_mask;
     
	MicroStackChain = ILibCreateChain();


	// TODO: Each device must have a unique device identifier (UDN)
	UPnPmicroStack = UPnPCreateMicroStack(MicroStackChain, "MusicDevice", "ba369211-059e-435d-a5f5-ad468174e365", "0000001", 1800, 0);


	UPnPFP_MusicService_assignAddress = (UPnP_ActionHandler_MusicService_assignAddress)&UPnPMusicService_assignAddress;
	UPnPFP_MusicService_play = (UPnP_ActionHandler_MusicService_play)&UPnPMusicService_play;
	UPnPFP_MusicService_stop = (UPnP_ActionHandler_MusicService_stop)&UPnPMusicService_stop;
	
	


	printf("MicroStack 1.0 - Sample Device \r\n\r\n");

ILib_Monitor = ILibCreateLifeTime(MicroStackChain);	ILib_IPAddressLength = ILibGetLocalIPAddressList(&ILib_IPAddressList);
	ILibLifeTime_Add(ILib_Monitor, NULL, 4, (void*)&ILib_IPAddressMonitor, NULL);
	sigemptyset(&block_mask);
	// Block other terminal-generated signals while handler runs.
    sigaddset(&block_mask, SIGINT);
    sigaddset(&block_mask, SIGQUIT);
    setup_action.sa_handler = BreakSink;
    setup_action.sa_mask = block_mask;
    setup_action.sa_flags = 0;
    sigaction(SIGINT, &setup_action, NULL);
	WaitForExit = 0;
	ILibStartChain(MicroStackChain);
	free(ILib_IPAddressList);
	return 0;
}

